var Gaffa = require('gaffa'),
    crel = require('crel'),
    viewType = "group";

function Group(){
    this.views.groups = new Gaffa.ViewContainer(this.views.groups);
    this.views.empty = new Gaffa.ViewContainer(this.views.empty);
}
Group = Gaffa.createSpec(Group, Gaffa.ContainerView);
Group.prototype.type = viewType;
Group.prototype.render = function(){
    
    var renderedElement = crel('div');
    
    this.views.groups.element = renderedElement;
    this.views.empty.element = renderedElement;
    
    this.renderedElement = renderedElement;
    
    this.__super__.render.apply(this, arguments);
}

function createNewView(property, templateKey, addedItem){
    if(!property.templateCache){
        property.templateCache= {};
    }
    var view = JSON.parse(
        property.templateCache[templateKey] || 
        (property.templateCache[templateKey] = JSON.stringify(property[templateKey]))
    );

    for(var key in addedItem){
        view[key] = addedItem[key];
    }

    return property.gaffa.initialiseViewItem(view, property.gaffa, property.gaffa.views.constructors);
}
       
Group.prototype.groups = new Gaffa.Property({
    update: Gaffa.propertyUpdaters.group(
        "groups",                     
        //increment
        function(viewModel, groups, addedItem){
            var listViews = viewModel.views.groups,
                property = viewModel.groups,
                groupContainer = createNewView(property, 'groupTemplate'),
                expression,
                newHeader,
                newList;

            for(var key in addedItem){
                groupContainer[key] = addedItem[key];
            }

            if(property.listTemplate){
                expression = '({items ' + property.listTemplate.list.binding + '}(filter [] {item (= (' + property.expression + ' item) "' + addedItem.group + '")}))';

                newList = createNewView(property, 'listTemplate', addedItem);

                newList.list.binding = expression;

                groupContainer.views.content.add(newList);
            }

            listViews.add(groupContainer);
        },
        //decrement
        function(viewModel, groups, removedItem){
            removedItem.remove();
        },
        //empty
        function(viewModel, insert){
            var emptyViews = viewModel.views.empty,
                property = viewModel.groups;
                
            if(!property.emptyTemplate){
                return;
            }
            
            if(insert){
                if(!emptyViews.length){
                    emptyViews.add(createNewView(property, 'emptyTemplate'));
                }
            }else{
                while(emptyViews.length){
                    emptyViews[0].remove();
                }
            }
        }
    ),
    trackKeys: true
});

module.exports = Group;